﻿using System;
using System.IO;
using System.Runtime.InteropServices;
using System.Text;

namespace gunmod
{
	// Token: 0x0200000E RID: 14
	public static class INIHelper
	{
		// Token: 0x060000B3 RID: 179
		[DllImport("kernel32")]
		private static extern int GetPrivateProfileString(string lpAppName, string lpKeyName, string lpDefault, StringBuilder lpReturnedString, int nSize, string lpFileName);

		// Token: 0x060000B4 RID: 180
		[DllImport("kernel32")]
		private static extern int WritePrivateProfileString(string lpApplicationName, string lpKeyName, string lpString, string lpFileName);

		// Token: 0x060000B5 RID: 181 RVA: 0x0000716C File Offset: 0x0000536C
		public static string Read(string section, string key, string def, string filePath)
		{
			StringBuilder stringBuilder = new StringBuilder(1024);
			INIHelper.GetPrivateProfileString(section, key, def, stringBuilder, 1024, filePath);
			return stringBuilder.ToString();
		}

		// Token: 0x060000B6 RID: 182 RVA: 0x0000719A File Offset: 0x0000539A
		public static int Write(string section, string key, string value, string filePath)
		{
			INIHelper.CheckPath(filePath);
			return INIHelper.WritePrivateProfileString(section, key, value, filePath);
		}

		// Token: 0x060000B7 RID: 183 RVA: 0x000071AB File Offset: 0x000053AB
		public static int DeleteSection(string section, string filePath)
		{
			return INIHelper.Write(section, null, null, filePath);
		}

		// Token: 0x060000B8 RID: 184 RVA: 0x000071B6 File Offset: 0x000053B6
		public static int DeleteKey(string section, string key, string filePath)
		{
			return INIHelper.Write(section, key, null, filePath);
		}

		// Token: 0x060000B9 RID: 185 RVA: 0x000071C1 File Offset: 0x000053C1
		private static void CheckPath(string filePath)
		{
			if (string.IsNullOrWhiteSpace(filePath) || !File.Exists(filePath))
			{
				throw new ArgumentNullException("filePath");
			}
		}
	}
}
