﻿using System;

namespace gunmod
{
	// Token: 0x02000008 RID: 8
	public struct Vector3
	{
		// Token: 0x06000055 RID: 85 RVA: 0x0000395C File Offset: 0x00001B5C
		public static Vector3[] mix(Vector3[] v1, Vector3[] v2)
		{
			Vector3[] array = new Vector3[v1.Length + v2.Length];
			int num = 0;
			for (int i = 0; i < v1.Length; i++)
			{
				array[num] = v1[i];
				num++;
			}
			for (int j = 0; j < v2.Length; j++)
			{
				array[num] = v2[j];
				num++;
			}
			return array;
		}

		// Token: 0x06000056 RID: 86 RVA: 0x000039B9 File Offset: 0x00001BB9
		public Vector3(double x0, double y0, double z0)
		{
			this.x = x0;
			this.y = y0;
			this.z = z0;
		}

		// Token: 0x06000057 RID: 87 RVA: 0x000039D0 File Offset: 0x00001BD0
		public static Vector3 operator +(Vector3 a, Vector3 b)
		{
			return new Vector3(a.x + b.x, a.y + b.y, a.z + a.z);
		}

		// Token: 0x06000058 RID: 88 RVA: 0x000039FE File Offset: 0x00001BFE
		public static Vector3 operator *(double a, Vector3 b)
		{
			return new Vector3(a * b.x, a * b.y, a * b.z);
		}

		// Token: 0x06000059 RID: 89 RVA: 0x00003A1D File Offset: 0x00001C1D
		public static Vector3 operator *(int a, Vector3 b)
		{
			return new Vector3((double)a * b.x, (double)a * b.y, (double)a * b.z);
		}

		// Token: 0x0600005A RID: 90 RVA: 0x00003A3F File Offset: 0x00001C3F
		public static Vector3 operator *(Vector3 b, double a)
		{
			return new Vector3(a * b.x, a * b.y, a * b.z);
		}

		// Token: 0x0600005B RID: 91 RVA: 0x00003A5E File Offset: 0x00001C5E
		public static Vector3 operator /(Vector3 b, double a)
		{
			return new Vector3(b.x / a, b.y / a, b.z / a);
		}

		// Token: 0x0600005C RID: 92 RVA: 0x00003A7D File Offset: 0x00001C7D
		public static Vector3 operator *(Vector3 b, int a)
		{
			return new Vector3((double)a * b.x, (double)a * b.y, (double)a * b.z);
		}

		// Token: 0x0600005D RID: 93 RVA: 0x00003A9F File Offset: 0x00001C9F
		public static Vector3 operator -(Vector3 a, Vector3 b)
		{
			return new Vector3(a.x - b.x, a.y - b.y, a.z - b.z);
		}

		// Token: 0x0600005E RID: 94 RVA: 0x00003ACD File Offset: 0x00001CCD
		public static Vector3 operator -(Vector3 a)
		{
			return new Vector3(-a.x, -a.y, -a.z);
		}

		// Token: 0x0600005F RID: 95 RVA: 0x00003AE9 File Offset: 0x00001CE9
		public double getx()
		{
			return this.x;
		}

		// Token: 0x06000060 RID: 96 RVA: 0x00003AF1 File Offset: 0x00001CF1
		public double gety()
		{
			return this.y;
		}

		// Token: 0x06000061 RID: 97 RVA: 0x00003AF9 File Offset: 0x00001CF9
		public double getz()
		{
			return this.z;
		}

		// Token: 0x06000062 RID: 98 RVA: 0x00003B01 File Offset: 0x00001D01
		public double Product(Vector3 v)
		{
			return this.x * v.x + this.y * v.y + this.z * v.z;
		}

		// Token: 0x06000063 RID: 99 RVA: 0x00003B2C File Offset: 0x00001D2C
		public Vector2 Vector2()
		{
			return new Vector2(this.x, this.y);
		}

		// Token: 0x06000064 RID: 100 RVA: 0x00003B40 File Offset: 0x00001D40
		public Vector3 plus(Vector3 v3)
		{
			Vector3 result;
			result.x = v3.x + this.x;
			result.y = v3.y + this.y;
			result.z = v3.z + this.z;
			return result;
		}

		// Token: 0x06000065 RID: 101 RVA: 0x00003B8C File Offset: 0x00001D8C
		public Vector3 minus(Vector3 v3)
		{
			Vector3 result;
			result.x = this.x - v3.x;
			result.y = this.y - v3.y;
			result.z = this.z - v3.z;
			return result;
		}

		// Token: 0x06000066 RID: 102 RVA: 0x00003BD8 File Offset: 0x00001DD8
		public double angle(Vector3 v3)
		{
			double result;
			if (Math.Acos(this.Product(v3) / (v3.moldheight() * this.moldheight())) / 3.141592653589793 * 180.0 > 0.0 || Math.Acos(this.Product(v3) / (v3.moldheight() * this.moldheight())) / 3.141592653589793 * 180.0 < 0.0)
			{
				result = Math.Acos(this.Product(v3) / (v3.moldheight() * this.moldheight())) / 3.141592653589793 * 180.0;
			}
			else
			{
				result = 0.0;
			}
			return result;
		}

		// Token: 0x06000067 RID: 103 RVA: 0x00003C96 File Offset: 0x00001E96
		public double moldheight()
		{
			return Math.Sqrt(this.x * this.x + this.y * this.y + this.z * this.z);
		}

		// Token: 0x06000068 RID: 104 RVA: 0x00003CC8 File Offset: 0x00001EC8
		public Vector3 Crossproduct(Vector3 v3)
		{
			Vector3 result;
			result.x = this.h2(this.y, this.z, v3.y, v3.z);
			result.y = -this.h2(this.x, this.z, v3.x, v3.z);
			result.z = this.h2(this.x, this.y, v3.x, v3.y);
			return result;
		}

		// Token: 0x06000069 RID: 105 RVA: 0x00003D46 File Offset: 0x00001F46
		private double h2(double a1, double a2, double b1, double b2)
		{
			return a1 * b2 - a2 * b1;
		}

		// Token: 0x0600006A RID: 106 RVA: 0x00003D50 File Offset: 0x00001F50
		private double abs(double d)
		{
			d = ((d >= 0.0) ? d : (-d));
			return d;
		}

		// Token: 0x0400000F RID: 15
		public double x;

		// Token: 0x04000010 RID: 16
		public double y;

		// Token: 0x04000011 RID: 17
		public double z;
	}
}
