﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Reflection;
using TaleWorlds.Core;
using TaleWorlds.Engine;
using TaleWorlds.Library;
using TaleWorlds.MountAndBlade;


namespace gunmod
{
	// Token: 0x0200000B RID: 11
	internal class riflegun
	{
		// Token: 0x06000073 RID: 115 RVA: 0x0000425C File Offset: 0x0000245C
		public static void getint()
		{
			if (!riflegun.hasIniReloaded)
			{
				string filePath =System.IO. Path.GetFullPath(System.IO.Path.Combine(System.IO.Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location), "..\\..\\")) + "/Config/Settings.ini";
				riflegun.hasIniReloaded = true;
				riflegun.Hreloadtime = (float)Convert.ToDouble(INIHelper.Read("装弹时间", "三眼神铳", "16", filePath)) + 2f;
				riflegun.Greloadtime = (float)Convert.ToDouble(INIHelper.Read("装弹时间", "步枪", "9", filePath)) + 2f;
				riflegun.Breloadtime = (float)Convert.ToDouble(INIHelper.Read("装弹时间", "双管步枪", "12", filePath)) + 2f;
				riflegun.Sreloadtime = (float)Convert.ToDouble(INIHelper.Read("装弹时间", "简易火铳", "10", filePath)) + 2f;
				riflegun.scaleSmoke = (int)Convert.ToDouble(INIHelper.Read("特效", "烟雾尺寸", "6", filePath));
				shootTogether.rate = (float)Convert.ToDouble(INIHelper.Read("齐射", "齐射比例", "0.9", filePath));
				shootTogether.fireTime = (float)Convert.ToDouble(INIHelper.Read("齐射", "强制开火时长", "4.5", filePath));
				dvMissionLogic.rate = (float)Convert.ToDouble(INIHelper.Read("穿盾", "伤害比例", "0.3", filePath));
				if (riflegun.Hreloadtime < 2f)
				{
					riflegun.Hreloadtime = 2f;
				}
				if (riflegun.Greloadtime < 2f)
				{
					riflegun.Greloadtime = 2f;
				}
				if (riflegun.Breloadtime < 2f)
				{
					riflegun.Breloadtime = 2f;
				}
				if (riflegun.Sreloadtime < 2f)
				{
					riflegun.Sreloadtime = 2f;
				}
				if (shootTogether.rate > 1f || shootTogether.rate < 0f)
				{
					shootTogether.rate = 0.9f;
				}
				if (dvMissionLogic.rate < 0f)
				{
					dvMissionLogic.rate = 0.3f;
				}
				if (shootTogether.fireTime < 1f)
				{
					shootTogether.fireTime = 1f;
				}
				if (riflegun.scaleSmoke + 3 < 0)
				{
					riflegun.scaleSmoke = -3;
				}
			}
		}

		// Token: 0x06000074 RID: 116 RVA: 0x00004474 File Offset: 0x00002674
		public bool canBeRemove()
		{
			if (this.shooter.Equipment != null)
			{
				for (int i = 0; i < 5; i++)
				{
					if (!this.shooter.Equipment[i].IsEmpty && this.shooter.Equipment[i].getGunType() == this.gunType)
					{
						return false;
					}
				}
			}
			return true;
		}

		// Token: 0x06000075 RID: 117 RVA: 0x000044D8 File Offset: 0x000026D8
		public MissionWeapon getRifle()
		{
			if (this.shooter != null && this.shooter.IsActive() && this.shooter.Equipment != null)
			{
				for (int i = 0; i < 5; i++)
				{
					if (this.shooter.Equipment[i].isCrossbow() && this.shooter.Equipment[i].getGunType() == this.gunType)
					{
						this.rifle = this.shooter.Equipment[i];
					}
				}
			}
			return this.rifle;
		}

		// Token: 0x06000076 RID: 118 RVA: 0x00004568 File Offset: 0x00002768
		public MissionWeapon getBullet()
		{
			MissionWeapon result = default(MissionWeapon);
			if (this.shooter != null && this.shooter.IsActive() && this.shooter.Equipment != null)
			{
				for (int i = 0; i < 5; i++)
				{
					if (this.shooter.Equipment[i].IsAnyAmmo())
					{
						result = this.shooter.Equipment[i];
					}
				}
			}
			return result;
		}

		// Token: 0x06000077 RID: 119 RVA: 0x000045DC File Offset: 0x000027DC
		public void preload()
		{
			this.firetimer = 0.01f;
			this.gunfire.SetEnable(true);
			this.spark.SetEnable(true);
			this.smoke.SetEnable(true);
			this.smoke2.SetEnable(true);
			this.smoke3.SetEnable(true);
			this.spark2.SetEnable(true);
			this.gunfire2.SetEnable(true);
			this.isfiring = true;
		}

		// Token: 0x06000078 RID: 120 RVA: 0x00004650 File Offset: 0x00002850
		public GameEntity getGunEntity()
		{
			GameEntity result = null;
			if (this.shooter.Equipment != null)
			{
				for (int i = 0; i < 5; i++)
				{
					if (!this.shooter.Equipment[i].IsEmpty && this.shooter.Equipment[i].getGunType() == this.gunType)
					{
						result = this.shooter.GetWeaponEntityFromEquipmentSlot((EquipmentIndex)i);
						break;
					}
				}
			}
			return result;
		}

		// Token: 0x06000079 RID: 121 RVA: 0x000046C4 File Offset: 0x000028C4
		public riflegun(Agent agent, MissionWeapon weapon)
		{
			this.shooter = agent;
			this.rifle = weapon;
			this.gunType = weapon.getGunType();
			float num = 3.1415925f;
			this.gunmesh = this.getGunEntity();
			Vec3 vec = default(Vec3);
			if (weapon.getGunType() == GunType.步枪)
			{
				vec=new  Vec3(0f, 0f, 1.15f, -1f);
				this.light_pos_onfoot = new Vec3(0f, 2.15f, 1.55f, -1f);
				this.light_pos_mount = new Vec3(0f, 0f, 1.55f, -1f);
				this.pin = Mesh.GetFromResource("spear_guard_14").CreateCopy();
				this.body = Mesh.GetFromResource("mace_handle_4").CreateCopy();
				Mesh mesh = Mesh.GetFromResource("aserai_grip_10").CreateCopy();
				Mesh mesh2 = Mesh.GetFromResource("axe_craft_10_handle").CreateCopy();
				Mesh mesh3 = Mesh.GetFromResource("khuzait_pommel_1").CreateCopy();
				Mesh mesh4 = Mesh.GetFromResource("aserai_pommel_3").CreateCopy();
				this.pinpos1 = new MatrixFrame(Mat3.Identity, new Vec3(0f, 0f, 0.07f, -1f));
				this.pinpos1.Rotate(num, new Vec3(1f, 0f, 0f, -1f));
				this.pinpos2 = new MatrixFrame(Mat3.Identity, new Vec3(0f, 0f, 0.085f, -1f));
				this.pinpos2.Rotate(num / 180f * 45f + num, new Vec3(1f, 0f, 0f, -1f));
				this.pin.SetLocalFrame(this.pinpos1);
				this.body.SetLocalFrame(new MatrixFrame(Mat3.Identity, new Vec3(0f, 0f, 1.15f, -1f)));
				this.gunpos1 = new MatrixFrame(Mat3.Identity, new Vec3(0f, 0f, 1.15f, -1f));
				this.gunpos2 = new MatrixFrame(Mat3.Identity, new Vec3(0f, 0f, -0.15f, -1f));
				this.pinpos3 = new MatrixFrame(Mat3.Identity, new Vec3(0f, 0f, -1.23f, -1f));
				this.pinpos1.Rotate(num, new Vec3(1f, 0f, 0f, -1f));
				MatrixFrame matrixFrame;
				matrixFrame=new MatrixFrame(Mat3.Identity, new Vec3(0f, -0.028f, -1.24f, -1f));
				MatrixFrame matrixFrame2;
				matrixFrame2 = new MatrixFrame(Mat3.Identity, new Vec3(0f, 0.035f, 0.25f, -1f));
				MatrixFrame matrixFrame3;
				matrixFrame3 = new MatrixFrame(Mat3.Identity, new Vec3(0f, 0.032f, -0.99f, -1f));
				matrixFrame2.Rotate(num / 180f * 90f, new Vec3(1f, 0f, 0f, -1f));
				matrixFrame2.Rotate(num / 180f * 90f, new Vec3(0f, 0f, 1f, -1f));
				matrixFrame3.Rotate(num / 180f * 90f, new Vec3(1f, 0f, 0f, -1f));
				matrixFrame.Rotate(-num / 180f * 12f, new Vec3(1f, 0f, 0f, -1f));
				this.body.AddMesh(mesh, matrixFrame);
				this.body.AddMesh(mesh2, new MatrixFrame(Mat3.Identity, new Vec3(0f, 0f, -0.42f, -1f)));
				this.body.AddMesh(mesh3, matrixFrame3);
				this.body.AddMesh(mesh4, matrixFrame2);
			}
			else if (weapon.getGunType() == GunType.双管步枪)
			{
				vec = new Vec3(0f, 0f, 1.15f, -1f);
				this.light_pos_onfoot = new Vec3(0f, 2.15f, 1.55f, -1f);
				this.light_pos_mount = new Vec3(0f, 0f, 1.55f, -1f);
				this.pin = Mesh.GetFromResource("spear_guard_14").CreateCopy();
				this.body = Mesh.GetFromResource("mace_handle_4").CreateCopy();
				Mesh mesh5 = Mesh.GetFromResource("aserai_grip_10").CreateCopy();
				Mesh mesh6 = Mesh.GetFromResource("axe_craft_10_handle").CreateCopy();
				Mesh mesh7 = Mesh.GetFromResource("khuzait_pommel_1").CreateCopy();
				Mesh mesh8 = Mesh.GetFromResource("aserai_pommel_3").CreateCopy();
				Mesh mesh9 = Mesh.GetFromResource("mace_handle_5").CreateCopy();
				Mesh mesh10 = Mesh.GetFromResource("mace_handle_5").CreateCopy();
				MatrixFrame matrixFrame4;
				matrixFrame4=new MatrixFrame(Mat3.Identity, new Vec3(0.010605f, 0f, 0.025f, -1f));
				MatrixFrame matrixFrame5;
				matrixFrame5=new MatrixFrame(Mat3.Identity, new Vec3(-0.010605f, 0f, 0.025f, -1f));
				this.pinpos1 = new MatrixFrame(Mat3.Identity, new Vec3(0f, 0f, 0.07f, -1f));
				this.pinpos1.Rotate(num, new Vec3(1f, 0f, 0f, -1f));
				this.pinpos2 = new MatrixFrame(Mat3.Identity, new Vec3(0f, 0f, 0.085f, -1f));
				this.pinpos2.Rotate(num / 180f * 45f + num, new Vec3(1f, 0f, 0f, -1f));
				this.pin.SetLocalFrame(this.pinpos1);
				this.body.SetLocalFrame(new MatrixFrame(Mat3.Identity, new Vec3(0f, 0f, 1.15f, -1f)));
				this.gunpos1 = new MatrixFrame(Mat3.Identity, new Vec3(0f, 0f, 1.15f, -1f));
				this.gunpos2 = new MatrixFrame(Mat3.Identity, new Vec3(0f, 0f, -0.15f, -1f));
				this.pinpos3 = new MatrixFrame(Mat3.Identity, new Vec3(0f, 0f, -1.23f, -1f));
				this.pinpos1.Rotate(num, new Vec3(1f, 0f, 0f, -1f));
				MatrixFrame matrixFrame6;
				matrixFrame6=new MatrixFrame(Mat3.Identity, new Vec3(0f, -0.028f, -1.24f, -1f));
				MatrixFrame matrixFrame7;
				matrixFrame7=new MatrixFrame(Mat3.Identity, new Vec3(0f, 0.035f, 0.25f, -1f));
				MatrixFrame matrixFrame8;
				matrixFrame8=new MatrixFrame(Mat3.Identity, new Vec3(0f, 0.032f, -0.99f, -1f));
				matrixFrame7.Rotate(num / 180f * 90f, new Vec3(1f, 0f, 0f, -1f));
				matrixFrame7.Rotate(num / 180f * 90f, new Vec3(0f, 0f, 1f, -1f));
				matrixFrame8.Rotate(num / 180f * 90f, new Vec3(1f, 0f, 0f, -1f));
				matrixFrame6.Rotate(-num / 180f * 12f, new Vec3(1f, 0f, 0f, -1f));
				this.body.AddMesh(mesh5, matrixFrame6);
				this.body.AddMesh(mesh6, new MatrixFrame(Mat3.Identity, new Vec3(0f, 0f, -0.42f, -1f)));
				this.body.AddMesh(mesh7, matrixFrame8);
				this.body.AddMesh(mesh8, matrixFrame7);
				this.body.AddMesh(mesh9, matrixFrame4);
				this.body.AddMesh(mesh10, matrixFrame5);
			}
			else if (this.gunType == GunType.三眼神铳)
			{
				vec=new Vec3(0f, 0f, 1.1f, -1f);
				this.light_pos_onfoot = new Vec3(0f, 1.7f, 1.55f, -1f);
				this.light_pos_mount = new Vec3(0f, 0f, 1.55f, -1f);
				this.body = Mesh.GetFromResource("mace_handle_8").CreateCopy();
				Mesh mesh11 = Mesh.GetFromResource("mace_handle_5").CreateCopy();
				Mesh mesh12 = Mesh.GetFromResource("mace_handle_5").CreateCopy();
				Mesh mesh13 = Mesh.GetFromResource("mace_handle_5").CreateCopy();
				this.gunpos1 = new MatrixFrame(Mat3.Identity, new Vec3(0f, -0.02f, 0.3f, -1f));
				this.body.SetLocalFrame(new MatrixFrame(Mat3.Identity, new Vec3(0f, -0.02f, 0.3f, -1f)));
				this.gunpos2 = new MatrixFrame(Mat3.Identity, new Vec3(0f, 0f, -0.74f, -1f));
				MatrixFrame matrixFrame9;
				matrixFrame9=new MatrixFrame(Mat3.Identity, new Vec3(0f, -0.0075f, 0.55f, -1f));
				MatrixFrame matrixFrame10;
				matrixFrame10=new MatrixFrame(Mat3.Identity, new Vec3(0.01275f, 0.015f, 0.55f, -1f));
				MatrixFrame matrixFrame11;
				matrixFrame11=new MatrixFrame(Mat3.Identity, new Vec3(-0.01275f, 0.015f, 0.55f, -1f));
				this.body.AddMesh(mesh11, matrixFrame9);
				this.body.AddMesh(mesh12, matrixFrame10);
				this.body.AddMesh(mesh13, matrixFrame11);
			}
			else if (this.gunType == GunType.简易火铳)
			{
				vec = new Vec3(0f, 0f, 1.1f, -1f);
				this.light_pos_onfoot = new Vec3(0f, 1.7f, 1.55f, -1f);
				this.light_pos_mount = new Vec3(0f, 0f, 1.55f, -1f);
				this.body = Mesh.GetFromResource("mace_handle_8").CreateCopy();
				Mesh mesh14 = Mesh.GetFromResource("mace_handle_5").CreateCopy();
				this.gunpos1 = new MatrixFrame(Mat3.Identity, new Vec3(0f, -0.02f, 0.3f, -1f));
				this.body.SetLocalFrame(new MatrixFrame(Mat3.Identity, new Vec3(0f, -0.02f, 0.3f, -1f)));
				this.gunpos2 = new MatrixFrame(Mat3.Identity, new Vec3(0f, 0f, -0.74f, -1f));
				MatrixFrame matrixFrame12;
				matrixFrame12 = new MatrixFrame(Mat3.Identity, new Vec3(0f, 0f, 0.55f, -1f));
				this.body.AddMesh(mesh14, matrixFrame12);
			}
			MatrixFrame matrixFrame13;
			matrixFrame13=new MatrixFrame (Mat3.Identity, new Vec3(0f, 0f, 0.3f, -1f) + vec);
			MatrixFrame matrixFrame14;
			matrixFrame14 = new MatrixFrame(Mat3.Identity, new Vec3(0f, 0f, 0.55f, -1f) + vec);
			MatrixFrame matrixFrame15;
			matrixFrame15 = new MatrixFrame(Mat3.Identity, new Vec3(0f, 0f, 0.45f, -1f) + vec);
			MatrixFrame matrixFrame16;
			matrixFrame16 = new MatrixFrame(Mat3.Identity, new Vec3(0f, 0f, 0.59f, -1f) + vec);
			MatrixFrame matrixFrame17;
			matrixFrame17 = new MatrixFrame(Mat3.Identity, new Vec3(0f, 0f, 0.9f, -1f) + vec);
			MatrixFrame matrixFrame18;
			matrixFrame18 = new
				 MatrixFrame(Mat3.Identity, vec);
			MatrixFrame matrixFrame19;
			matrixFrame19 = new MatrixFrame(Mat3.Identity, new Vec3(0f, 0f, 0.05f, -1f) + vec);
			this.gunfire = ParticleSystem.CreateParticleSystemAttachedToBone("psys_game_burning_agent", agent.AgentVisuals.GetSkeleton(), Game.Current.HumanMonster.MainHandItemBoneIndex, ref matrixFrame13);
			this.spark = ParticleSystem.CreateParticleSystemAttachedToBone("psys_game_sparkle_a", agent.AgentVisuals.GetSkeleton(), Game.Current.HumanMonster.MainHandItemBoneIndex, ref matrixFrame18);
			this.smoke2 = ParticleSystem.CreateParticleSystemAttachedToBone("psys_game_burning_jar_trail", agent.AgentVisuals.GetSkeleton(), Game.Current.HumanMonster.MainHandItemBoneIndex, ref matrixFrame16);
			this.gunfire2 = ParticleSystem.CreateParticleSystemAttachedToBone("psys_game_burning_agent", agent.AgentVisuals.GetSkeleton(), Game.Current.HumanMonster.MainHandItemBoneIndex, ref matrixFrame14);
			this.smoke = ParticleSystem.CreateParticleSystemAttachedToBone("psys_game_burning_jar_trail", agent.AgentVisuals.GetSkeleton(), Game.Current.HumanMonster.MainHandItemBoneIndex, ref matrixFrame15);
			this.spark2 = ParticleSystem.CreateParticleSystemAttachedToBone("psys_game_sparkle_a", agent.AgentVisuals.GetSkeleton(), Game.Current.HumanMonster.MainHandItemBoneIndex, ref matrixFrame19);
			this.smoke3 = ParticleSystem.CreateParticleSystemAttachedToBone("psys_game_burning_jar_trail", agent.AgentVisuals.GetSkeleton(), Game.Current.HumanMonster.MainHandItemBoneIndex, ref matrixFrame17);
			this.smokes = new List<ParticleSystem>();
			for (int i = 0; i < riflegun.scaleSmoke; i++)
			{
				for (int j = 0; j < 3 + i; j++)
				{
					MatrixFrame matrixFrame20;
					matrixFrame20 = new MatrixFrame(Mat3.Identity, new Vec3((float)Math.Sin((double)(num * 2f / (float)(3 + i) * (float)j)) * 0.14f * (float)(1 + i), (float)Math.Cos((double)(num * 2f / (float)(3 + i) * (float)j)) * 0.14f * (float)(1 + i), 0.28f * (float)(1 + i), -1f) + vec);
					this.smokes.Add(ParticleSystem.CreateParticleSystemAttachedToBone("psys_game_burning_jar_trail", agent.AgentVisuals.GetSkeleton(), Game.Current.HumanMonster.MainHandItemBoneIndex, ref matrixFrame20));
				}
			}
			this.light = Light.CreatePointLight(1.8f);
			this.light.Intensity = 0f;
			this.light.ShadowEnabled = true;
			this.light.LightColor = new Vec3(128f, 83f, 0f, -1f);
			agent.AgentVisuals.GetEntity().AddMeshToBone(Game.Current.HumanMonster.MainHandItemBoneIndex, this.body);
			if (this.gunType == GunType.步枪 || this.gunType == GunType.双管步枪)
			{
				agent.AgentVisuals.GetEntity().AddMeshToBone(Game.Current.HumanMonster.MainHandItemBoneIndex, this.pin);
			}
			agent.AgentVisuals.GetEntity().AddLight(this.light);
			this.firetimer = 0f;
			this.all = Mesh.GetFromResource("battania_pommel_9").CreateCopy();
			this.all.AddMesh(this.body.CreateCopy(), new MatrixFrame(Mat3.Identity, new Vec3(0f, 0f, 0f, -1f)));
			if (this.gunType == GunType.步枪 || this.gunType == GunType.双管步枪)
			{
				this.all.AddMesh(this.pin.CreateCopy(), new MatrixFrame(Mat3.Identity, new Vec3(0f, 0f, 0f, -1f)));
			}
			this.gunmesh.AddMeshToBone(0, this.all);
			this.preload();
			this.hidegun();
		}

		// Token: 0x0600007A RID: 122 RVA: 0x0000571E File Offset: 0x0000391E
		public bool isshooterplayer()
		{
			return this.shooter == Agent.Main;
		}

		// Token: 0x0600007B RID: 123 RVA: 0x00005730 File Offset: 0x00003930
		public void ontick(float dt)
		{
			if (this.reloadtimer > 0f && this.shooter != null && this.shooter.IsActive())
			{
				ActionIndexCache currentAction = this.shooter.GetCurrentAction(1);
				if (currentAction != null && currentAction.Name.Contains("act_reload_crossbow"))
				{
					this.reloadtimer -= dt;
					this.shooter.SetCurrentActionSpeed(1, 2f);
					if (!currentAction.Name.Contains("horseback"))
					{
						this.shooter.SetActionChannel(1, ActionIndexCache.Create("act_reload_crossbow_horseback"), false, 0UL, 0f, 1f, -0.2f, 0.4f, 0f, false, -0.2f, 0, true);
						return;
					}
					if (!currentAction.Name.Contains("continue"))
					{
						if (this.shooter.GetCurrentActionProgress(1) > 0.3f && (this.gunType == GunType.步枪 || this.gunType == GunType.双管步枪))
						{
							this.pin.SetLocalFrame(this.pinpos1);
						}
						if (this.shooter.GetCurrentActionProgress(1) > 0.54f)
						{
							this.body.SetLocalFrame(this.gunpos2);
							this.shooter.SetActionChannel(1, ActionIndexCache.Create("act_reload_crossbow_continue_horseback"), false, 0UL, 0f, 1f, -0.2f, 0.4f, 0f, false, -0.2f, 0, true);
							this.shooter.SetCurrentActionProgress(1, 0f);
							if (this.gunType == GunType.步枪 || this.gunType == GunType.双管步枪)
							{
								this.pin.SetLocalFrame(this.pinpos3);
							}
							this.shooter.SetCurrentActionSpeed(1, 5E-06f);
							return;
						}
					}
					else if (this.reloadtimer >= 2f && this.shooter.GetCurrentActionProgress(1) > 0.5f)
					{
						this.body.SetLocalFrame(this.gunpos2);
						this.shooter.SetCurrentActionProgress(1, 0.42f);
						this.shooter.SetCurrentActionSpeed(1, 5E-06f);
						return;
					}
				}
				else if (this.getRifle().isCrossbow() && this.getRifle().getGunType() == this.gunType && !this.getRifle().AmmoWeapon.IsEmpty)
				{
					this.body.SetLocalFrame(this.gunpos1);
					if (this.gunType == GunType.步枪 || this.gunType == GunType.双管步枪)
					{
						this.pin.SetLocalFrame(this.pinpos1);
					}
					this.reloadtimer = 0f;
				}
			}
		}

		// Token: 0x0600007C RID: 124 RVA: 0x000059C8 File Offset: 0x00003BC8
		public void checkgun()
		{
			if (this.shooter != null && this.shooter.IsActive())
			{
				if (!this.shooter.WieldedWeapon.IsEmpty && this.shooter.WieldedWeapon.getGunType() == this.gunType)
				{
					this.showgun();
					if (!this.shooter.WieldedWeapon.AmmoWeapon.IsEmpty && (this.gunType == GunType.步枪 || this.gunType == GunType.双管步枪))
					{
						this.pin.SetLocalFrame(this.pinpos1);
						return;
					}
				}
				else
				{
					this.hidegun();
				}
			}
		}

		// Token: 0x0600007D RID: 125 RVA: 0x00005A67 File Offset: 0x00003C67
		public void showgun()
		{
			this.body.SetVisibilityMask((VisibilityMaskFlags)17);
			if (this.gunType == GunType.步枪 || this.gunType == GunType.双管步枪)
			{
				this.pin.SetVisibilityMask((VisibilityMaskFlags)17);
			}
			this.all.SetVisibilityMask(unchecked((VisibilityMaskFlags) (- 1048576)));
		}

		// Token: 0x0600007E RID: 126 RVA: 0x00005AA8 File Offset: 0x00003CA8
		public void hidegun()
		{
			this.body.SetVisibilityMask(unchecked( (VisibilityMaskFlags) (- 1048576)));
			if (this.gunType == GunType.步枪 || this.gunType == GunType.双管步枪)
			{
				this.pin.SetVisibilityMask(unchecked((VisibilityMaskFlags)(-1048576)));
			}
			this.all.SetVisibilityMask((VisibilityMaskFlags)17);
		}

		// Token: 0x0600007F RID: 127 RVA: 0x00005AF4 File Offset: 0x00003CF4
		public void openfire()
		{
			if (this.gunType == GunType.步枪)
			{
				this.reloadtimer = riflegun.Greloadtime;
				this.pin.SetLocalFrame(this.pinpos2);
			}
			else if (this.gunType == GunType.双管步枪)
			{
				this.reloadtimer = riflegun.Breloadtime;
				this.pin.SetLocalFrame(this.pinpos2);
			}
			else if (this.gunType == GunType.三眼神铳)
			{
				this.reloadtimer = riflegun.Hreloadtime;
			}
			else if (this.gunType == GunType.简易火铳)
			{
				this.reloadtimer = riflegun.Sreloadtime;
			}
			if (!this.isfiring)
			{
				if (this.shooter.Velocity.Length < 2f)
				{
					this.firetimer = 0.08f;
				}
				else
				{
					this.firetimer = 0.04f;
				}
				this.gunfire.SetEnable(true);
				this.spark.SetEnable(true);
				this.smoke.SetEnable(true);
				this.smoke2.SetEnable(true);
				this.smoke3.SetEnable(true);
				this.spark2.SetEnable(true);
				this.gunfire2.SetEnable(true);
				this.smokes.show();
				this.isfiring = true;
				this.light.Intensity = 100f;
				new Vec3(this.shooter.LookDirection.x, -this.shooter.LookDirection.y, this.shooter.LookDirection.z, -1f);
				if (this.shooter.MountAgent == null)
				{
					this.light.Frame = new MatrixFrame(Mat3.Identity, this.light_pos_onfoot);
					return;
				}
				this.light.Frame = new MatrixFrame(Mat3.Identity, this.light_pos_mount);
			}
		}

		// Token: 0x06000080 RID: 128 RVA: 0x00005CAC File Offset: 0x00003EAC
		public void updata(float dt)
		{
			if (this.shooter != null && this.shooter.IsActive() && this.isfiring)
			{
				if (this.light.Intensity > 25f)
				{
					this.light.Intensity -= 25f;
				}
				else
				{
					this.light.Intensity = 0f;
				}
				if (this.firetimer < 0f)
				{
					this.gunfire.SetEnable(false);
					this.spark.SetEnable(false);
					this.smoke.SetEnable(false);
					this.smoke2.SetEnable(false);
					this.gunfire2.SetEnable(false);
					this.spark2.SetEnable(false);
					this.smoke3.SetEnable(false);
					this.isfiring = false;
					this.smokes.hide();
					this.light.Intensity = 0f;
					return;
				}
				this.firetimer -= dt;
			}
		}

		// Token: 0x06000081 RID: 129 RVA: 0x00005DAC File Offset: 0x00003FAC
		public bool isgun(Agent entity, GunType gunType)
		{
			return entity == this.shooter && gunType == this.gunType;
		}

		// Token: 0x06000082 RID: 130 RVA: 0x00005DC2 File Offset: 0x00003FC2
		public bool hasgun(Agent entity)
		{
			return entity == this.shooter;
		}

		// Token: 0x04000023 RID: 35
		private static bool hasIniReloaded = false;

		// Token: 0x04000024 RID: 36
		private static float Hreloadtime = 17f;

		// Token: 0x04000025 RID: 37
		private static float Breloadtime = 14f;

		// Token: 0x04000026 RID: 38
		private static float Sreloadtime = 9f;

		// Token: 0x04000027 RID: 39
		private static float Greloadtime = 10f;

		// Token: 0x04000028 RID: 40
		private static int scaleSmoke = 5;

		// Token: 0x04000029 RID: 41
		private float reloadtimer;

		// Token: 0x0400002A RID: 42
		private Agent shooter;

		// Token: 0x0400002B RID: 43
		private MissionWeapon rifle;

		// Token: 0x0400002C RID: 44
		private ParticleSystem gunfire;

		// Token: 0x0400002D RID: 45
		private ParticleSystem spark;

		// Token: 0x0400002E RID: 46
		private ParticleSystem spark2;

		// Token: 0x0400002F RID: 47
		private ParticleSystem gunfire2;

		// Token: 0x04000030 RID: 48
		private ParticleSystem smoke2;

		// Token: 0x04000031 RID: 49
		private ParticleSystem smoke;

		// Token: 0x04000032 RID: 50
		private ParticleSystem smoke3;

		// Token: 0x04000033 RID: 51
		private List<ParticleSystem> smokes = new List<ParticleSystem>();

		// Token: 0x04000034 RID: 52
		private Mesh body;

		// Token: 0x04000035 RID: 53
		private Mesh pin;

		// Token: 0x04000036 RID: 54
		private Mesh all;

		// Token: 0x04000037 RID: 55
		private MatrixFrame pinpos1;

		// Token: 0x04000038 RID: 56
		private MatrixFrame pinpos2;

		// Token: 0x04000039 RID: 57
		private MatrixFrame pinpos3;

		// Token: 0x0400003A RID: 58
		private MatrixFrame gunpos1;

		// Token: 0x0400003B RID: 59
		private MatrixFrame gunpos2;

		// Token: 0x0400003C RID: 60
		private Vec3 light_pos_onfoot;

		// Token: 0x0400003D RID: 61
		private Vec3 light_pos_mount;

		// Token: 0x0400003E RID: 62
		private float firetimer;

		// Token: 0x0400003F RID: 63
		private bool isfiring;

		// Token: 0x04000040 RID: 64
		private Light light;

		// Token: 0x04000041 RID: 65
		private GameEntity gunmesh;

		// Token: 0x04000042 RID: 66
		private GunType gunType;

		// Token: 0x04000043 RID: 67
		public static int c = 0;

		// Token: 0x04000044 RID: 68
		private int direction = 1;
	}
}
